/*
   (c) 2021 Christian Grieger
   GNU GENERAL PUBLIC LICENSE
*/

#include <StreetLighting.h>

StreetLighting::StreetLighting (byte ledPin, byte ldrPin, int sensorOff, int sensorOn)
{
  pinLED = ledPin;
  pinLDR = ldrPin;

  sensorUpper = sensorOff;
  sensorLower = sensorOn;

  pinMode(pinLED, OUTPUT);
  pinMode(pinLDR, INPUT);

  ledState = false;
  digitalWrite(pinLED, LOW);

  nextMeasuring = (long)millis() + 1000;
}

void StreetLighting::update()
{
  if ((long)millis() - nextMeasuring >= 0) {

    int val = analogRead(pinLDR);
    if (ledState == false) {
      if (val <= sensorLower) {
        toggleLeds();
      }
    } else {
      if (val >= sensorUpper) {
        toggleLeds();
      }
    }

    nextMeasuring = (long)millis() + 1000;
  }
}

void StreetLighting::toggleLeds()
{
  if (ledState == false) {
    for (int i = 0; i <= 255; i++) {
      analogWrite(pinLED, i);
      delay(5);
    }
    digitalWrite(pinLED, HIGH);
  } else {
    for (int i = 255; i >= 0; i--) {
      analogWrite(pinLED, i);
      delay(5);
    }
    digitalWrite(pinLED, LOW);
  }

  ledState = !ledState;
}

