/*
   (c) 2021 Christian Grieger
   GNU GENERAL PUBLIC LICENSE
*/

#ifndef STREETLIGHTING_H
#define STREETLIGHTING_H

#include <Arduino.h>

class StreetLighting
{
  public:
    /*
       Constructor which resets all relevant values and connects the LED to the pin of the Arduino.

           ledPin     Number of the pin connecting the LED(s) to the Arduino (PWM-capable pin)
           ldrPin     Number of the pin connecting the LDR to the Arduino (analogue pin)
           sensorOn   Upper sensor value when the light should turn off
           senroOff   Lower sensor value when the light should turn on
    */
    StreetLighting (byte ledPin, byte ldrPin, int sensorOff, int sensorOn);

    /*
       Update routine which should be called in the main loop()-function
    */
    void update();

  protected:
    bool ledState;
    byte pinLED;
    byte pinLDR;
    int sensorUpper;
    int sensorLower;
    long nextMeasuring;

    void toggleLeds();
};

#endif
